 codeunit 50147 PartnerNavigateProMgt 
 {
     trigger OnRun()
     begin
         
     end;
     
     var
         myInt: Integer;
         cuNavigateProserializer: Codeunit 70104171;
         pageNavigatePro : page 70104170;
         jsonData: JsonObject;
         iJsonLastIndexDoc: integer;
         iJsonLastIndexRel: integer;


  [EventSubscriber(ObjectType::Codeunit, 70104170, 'onBeforeStartNavigateProPage42', '', false, false)]
   procedure fStartFromSalesOrder(Rec: record 36; var isHandled:boolean)
   //This code is just for example (a working one). You can optimize as you wish.  
      var
        myJsonObject: JsonObject;
        //record variables to manage
        tSalesHeader: Record 36;
    
     begin
        
        isHandled := true; //To skip original behaviors 
         
        //Fill json with documents and relationships.
        //-----------------------------------------------------------------------------------------------------
        clear(jsonData);
        //-----------------------------------------------------------------------------------------------------
        //Here you can add your own search routine to find documents, filling a json object
        fPrepareMyDocForAddin();      //Just for example  
        fPrepareMyRelForAddin();      //Just for example
        //-----------------------------------------------------------------------------------------------------
        //Send Data to Link codeunit
        cuNavigateProserializer.fSetJsonData(jsonData);
        //-----------------------------------------------------------------------------------------------------
        //Initialize addin page 
        pageNavigatePro.fPartnerInitializer();
        //Run Addinpage
        pageNavigatePro.run();
    
    end;

   [EventSubscriber(ObjectType::Codeunit, 70104170, 'onBeforeStartNavigateProPage9307', '', false, false)]
   procedure fStartFromPurchaseOrder(Rec: record 38; var isHandled:boolean)
   begin
        isHandled := true; //To skip original behaviors 
         
        //Fill json with documents and relationships.
        //-----------------------------------------------------------------------------------------------------
        clear(jsonData);
        //-----------------------------------------------------------------------------------------------------
        //Here you can add your own search routine to find documents, filling a json object
        fPrepareMyDocForAddin();      //Just for example  
        fPrepareMyRelForAddin();      //Just for example
        //-----------------------------------------------------------------------------------------------------
        //Send Data to Link codeunit
        cuNavigateProserializer.fSetJsonData(jsonData);
        //-----------------------------------------------------------------------------------------------------
        //Initialize addin page 
        pageNavigatePro.fPartnerInitializer();
        //Run Addinpage
        pageNavigatePro.run();
   end;


    procedure fPrepareMyDocForAddin(); 
    var
        myJsonObject: JsonObject;
    begin
        //Fill json variabile with information you want to print on images
        //The first parameter in each myJsonObject.Add is fixed, it must not be changed
         iJsonLastIndexDoc+=1;
         Clear(myJsonObject);
         myJsonObject.Add('sType'       , 'Document'          ); //<<--- Fixed. It must be "Document"
         myJsonObject.Add('sTableName'  , 'NEW1  '            ); //<<--- Here you can put everything you want. Up to 3 lines. Central block. Too long word go to next line 
         myJsonObject.Add('sDocumentNo' , 'Document02'        ); //<<--- Here you can put everything you want. Up to 20 Chars. First line
         myJsonObject.Add('iLevel'      , '0'                 ); //<<--- In which column I will draw the image (0-5)
         myJsonObject.Add('sDate'       , '01/01/2021'        ); //<<--- Here you can put everything you want. Up to 20 Chars. Last line. Qith Versione 10.0.3.0 it must be a date
         myJsonObject.Add('sDescription', 'Add. info1'        ); //<<--- This field will not be shown in the graph, but it will be exported in Excel. For addition information
         myJsonObject.Add('bDocExists'  , 'True'              ); //<<--- This field is not used in the layout. It indicates existing documents, without searching them again
         jsonData.Add(Format(iJsonLastIndexDoc), myJsonObject ); //<<--- Key to find data. EntryNo
         iJsonLastIndexDoc+=1;

         Clear(myJsonObject);
         myJsonObject.Add('sType'       , 'Document'          );
         myJsonObject.Add('sTableName'  , 'NEW2'              );
         myJsonObject.Add('sDocumentNo' , 'Document020'       );
         myJsonObject.Add('iLevel'      , '1'                 );
         myJsonObject.Add('sDate'       , '01/01/2021'        ); 
         myJsonObject.Add('sDescription', 'Add. info1'        );
         myJsonObject.Add('bDocExists'  , 'True'              );
         jsonData.Add(format(iJsonLastIndexDoc), myJsonObject ); 
         iJsonLastIndexDoc+=1;

         Clear(myJsonObject);
         myJsonObject.Add('sType'       , 'Document'          );
         myJsonObject.Add('sTableName'  , 'NEW3'              );
         myJsonObject.Add('sDocumentNo' , 'Document023'       );
         myJsonObject.Add('iLevel'      , '2'                 );
         myJsonObject.Add('sDate'       , '01/01/2021'        );
         myJsonObject.Add('sDescription', 'Add. info1'        );
         myJsonObject.Add('bDocExists'  , 'True'              );
         jsonData.Add(format(iJsonLastIndexDoc), myJsonObject ); 
         iJsonLastIndexDoc+=1;

         Clear(myJsonObject);
         myJsonObject.Add('sType'       , 'Document'          );
         myJsonObject.Add('sTableName'  , 'NEW4'              );
         myJsonObject.Add('sDocumentNo' , 'Document023'       );
         myJsonObject.Add('iLevel'      , '3'                 );
         myJsonObject.Add('sDate'       , '01/01/2021'        );
         myJsonObject.Add('sDescription', 'Add. info1'        );
         myJsonObject.Add('bDocExists'  , 'True'              );
         jsonData.Add(format(iJsonLastIndexDoc), myJsonObject );
          
    end;

    procedure fPrepareMyRelForAddin(); 
    var
        myJsonObject: JsonObject;
    begin
          //Preparing Reelationship Json

          //The first parameter in each myJsonObject.Add is fixed, it must not be changed
          iJsonLastIndexrel := iJsonLastIndexDoc +1; //Relationship continue the index number
          Clear(myJsonObject);
          myJsonObject.Add('sType'         , 'Relationship'   ); //<<--- Fixed. It must be "Relationshp"
          myJsonObject.Add('iFatherEntryNo', '1'              ); //<<--- Starting point of the arrow line. The number is the document index inside the json
          myJsonObject.Add('iDocEntryNo'   , '2'              ); //<<--- Ending point of the arrow line. The number is the document index inside the json
          myJsonObject.Add('iLinkType'     , '0'              ); //<<--- 0 full gray line, 1 dotted gray line. (don't use other numbers, they are not handle by engine)
          jsonData.Add(format(iJsonLastIndexrel), myJsonObject); //<<--- Key to find data. EntryNo. Continue the documents index
          iJsonLastIndexrel+=1;

          Clear(myJsonObject);
          myJsonObject.Add('sType'         , 'Relationship'   );
          myJsonObject.Add('iFatherEntryNo', '1'              );
          myJsonObject.Add('iDocEntryNo'   , '3'              );
          myJsonObject.Add('iLinkType'     , '1'              );
          jsonData.Add(format(iJsonLastIndexrel), myJsonObject); 
          iJsonLastIndexrel+=1;

          Clear(myJsonObject);
          myJsonObject.Add('sType'         , 'Relationship'   );
          myJsonObject.Add('iFatherEntryNo', '3'              );
          myJsonObject.Add('iDocEntryNo'   , '4'              );
          myJsonObject.Add('iLinkType'     , '1'              );
          jsonData.Add(format(iJsonLastIndexrel), myJsonObject); 
    end;






//Right Click and Double Click Test example

[EventSubscriber(ObjectType::Page, 70104170,'OnDoubleClickEventEntryNo','' , false, false)]
procedure PartnerDoubleClick(iEntryno:Integer;bIsHandled: Boolean)
var
    
begin

  
  Message('Double Click Entry No %1', iEntryno);

end;

[EventSubscriber(ObjectType::Page, 70104170,'OnRightClickEventEntryNo','' , false, false)]
local procedure PartnerRightClick(iEntryno:Integer)
var
    
begin
    Message('Right Click Entry No %1', iEntryno);
end;

//Available just with version 100.0.3.0
[EventSubscriber(ObjectType::Page, Page::IST_NavigatePro,'OnDoubleClickEventEntryNoJson','' , false, false)]
procedure PartnerDoubleClickWithJson(iEntryno:Integer; jsonData:JsonObject; bIsHandled: Boolean)
var
    
begin
    if bIsHandled then 
        exit; //Check To prevent multiple subscribing

    bIsHandled := true; //Force the field to stop further subscribing

    Message('You just Double click Entry No: %1 and this is your data set: %2',iEntryno,jsonData);
    
end;




 }